//
//  csProjectViewController.m
//  csProject
//
//  Created by Paul Solt on 6/10/11.
//  Copyright 2011 RIT. All rights reserved.
//

#import "csProjectViewController.h"

@implementation csProjectViewController

@synthesize myButton, myTextField, myView;

- (IBAction)buttonPressed:(id)sender {
    
    // Do something with the press
    NSLog(@"Hello there!");
    myTextField.text = @"hello there!";
}

- (void)tapGesture:(UITapGestureRecognizer *)theTapGesture {
    
    [self.view bringSubviewToFront:myView];
    CGPoint location = [theTapGesture locationInView:self.view];
    
    myTextField.text = NSStringFromCGPoint(location);
    
    CGPoint myPoint = [theTapGesture locationInView:myButton];
    
    if([myButton pointInside:myPoint withEvent:nil]) {
        
    } else {
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:.3];
        [UIView setAnimationCurve:UIViewAnimationCurveEaseOut];
        
        [myView setCenter:location];
        [myView setBounds:CGRectMake(0, 0, location.x, location.y)];
        
        [UIView commitAnimations];
    }
}

- (void)panGesture:(UIPanGestureRecognizer *)thePanGesture {
    CGPoint location = [thePanGesture locationInView:self.view];

    [self.view sendSubviewToBack:myView];
    [myView setCenter:location];

}

- (void)dealloc
{
    [myButton release];
    [myTextField release];
    [myView release];
    
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];


    UITapGestureRecognizer *tapGesture = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapGesture:)];
    
    [tapGesture setNumberOfTapsRequired:1];
    [tapGesture setNumberOfTouchesRequired:1];
    
    tapGesture.cancelsTouchesInView = NO;
    [self.view addGestureRecognizer:tapGesture];
    [tapGesture release];
    
    UIPanGestureRecognizer *panGesture = [[UIPanGestureRecognizer alloc] initWithTarget:self
                                                                                 action:@selector(panGesture:)];
    
    [self.view addGestureRecognizer:panGesture];
    [panGesture release];
}


- (void)viewDidUnload
{
    [myButton release];
    myButton = nil;
    
    [myTextField release];
    myTextField = nil;
    
    [myView release];
    myView = nil;
    
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
